﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using ZugriffAusAccess;
using Microsoft.Office.Interop.Access;
using System.Collections;

namespace ZugriffAusAccessInterop
{
    [ComVisible(true)]
    [ClassInterface(ClassInterfaceType.AutoDual)]
    public class ZugriffAusAccessInterop
    {


        private ZugriffAusAccess.ZugriffAusAccess logikmitLaufzeitUeberEineFunktion;

        public  ZugriffAusAccessInterop(){}

        public int GetWert(int zahl1, int zahl2)
        {
            ZugriffAusAccess.ZugriffAusAccess logik = new ZugriffAusAccess.ZugriffAusAccess();
            return logik.GetErgebnisInt(zahl1, zahl2);            
        }

        public string GetWertString(int zahl1, int zahl2)
        {
            ZugriffAusAccess.ZugriffAusAccess logik = new ZugriffAusAccess.ZugriffAusAccess();
            return logik.GetErgebnisString(zahl1, zahl2);
        }

        [return: MarshalAs(UnmanagedType.Currency)]
        public decimal GetRente([MarshalAs(UnmanagedType.Currency)] decimal gehalt, DateTime geburtstag, int RentenAlter, [MarshalAs(UnmanagedType.Currency)]  decimal Gehaltssteigerung)
        {
            ZugriffAusAccess.ZugriffAusAccess logik = new ZugriffAusAccess.ZugriffAusAccess();
            return logik.GetGehalt(gehalt, geburtstag, RentenAlter, Gehaltssteigerung);
        }

        public void macheEtwas(ref Microsoft.Office.Interop.Access.Dao.Database Database)
        {

            ZugriffAusAccess.ZugriffAusAccess logik = new ZugriffAusAccess.ZugriffAusAccess();
            logik.macheEtwasDirektMitDemAccessObjekt(ref Database);
        }

       
        public int oeffneFormular(string PrameterSemikolonSepariert)
        {
               ZugriffAusAccess.ZugriffAusAccess logik = new ZugriffAusAccess.ZugriffAusAccess();
               logik.oeffneFormular(PrameterSemikolonSepariert);
               return logik.Status;
        }


        public void bCreateLogikUeberMehrereFunktionen()
        {
            logikmitLaufzeitUeberEineFunktion = new ZugriffAusAccess.ZugriffAusAccess();
        }

        public void bDeleteLogikUeberMehrereFunktionen()
        {
            logikmitLaufzeitUeberEineFunktion = null;
        }

        public void oeffneFormularMitKeepAlive(string prameter)
        {
            logikmitLaufzeitUeberEineFunktion.oeffneFormular(prameter);
        }

        public int GetStatusAusKeepAlive()
        {
            return logikmitLaufzeitUeberEineFunktion.GetSTatus();
        }

        public string GetParameterAusKeepAlive()
        {
            
            return logikmitLaufzeitUeberEineFunktion.parameter;
        }


        public void SetParameterFuerKeepAlive(string parameter)
        {
            logikmitLaufzeitUeberEineFunktion.parameter = parameter;
        }


        public Boolean bFormGeladen()
        {
            return logikmitLaufzeitUeberEineFunktion.FormIsOpen();
        }

        public string GetParameterNichtModal()
        {
            return logikmitLaufzeitUeberEineFunktion.GetParameterNichtModal();
        }

        public int GetStatusNichtModal()
        {
            return logikmitLaufzeitUeberEineFunktion.GetSTatusNichtModal();
        }
    }
}
