﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.InteropServices
Imports System.Text
Imports ZugriffAusAccess
Imports Microsoft.Office.Interop.Access
Imports System.Collections

Namespace ZugriffAusAccessInterop
    <ComVisible(True)>
    <ClassInterface(ClassInterfaceType.AutoDual)>
    Public Class ZugriffAusAccessInterop
        Private logikmitLaufzeitUeberEineFunktion As ZugriffAusAccess.ZugriffAusAccess

        Public Sub New()
        End Sub

        Public Function GetWert(ByVal zahl1 As Integer, ByVal zahl2 As Integer) As Integer
            Dim logik As ZugriffAusAccess.ZugriffAusAccess = New ZugriffAusAccess.ZugriffAusAccess()
            Return logik.GetErgebnisInt(zahl1, zahl2)
        End Function

        Public Function GetWertString(ByVal zahl1 As Integer, ByVal zahl2 As Integer) As String
            Dim logik As ZugriffAusAccess.ZugriffAusAccess = New ZugriffAusAccess.ZugriffAusAccess()
            Return logik.GetErgebnisString(zahl1, zahl2)
        End Function

        Public Function GetRente(
       <MarshalAs(UnmanagedType.Currency)> ByVal gehalt As Decimal, ByVal geburtstag As DateTime, ByVal RentenAlter As Integer,
       <MarshalAs(UnmanagedType.Currency)> ByVal Gehaltssteigerung As Decimal) As <MarshalAs(UnmanagedType.Currency)> Decimal
            Dim logik1 As ZugriffAusAccess.ZugriffAusAccess = New ZugriffAusAccess.ZugriffAusAccess()
            Dim ergebnis As Decimal
            ergebnis = logik1.GetGehalt(gehalt, geburtstag, RentenAlter, Gehaltssteigerung)
            Return ergebnis
        End Function

        Public Sub macheEtwas(ByRef Database As Microsoft.Office.Interop.Access.Dao.Database)
            Dim logik As ZugriffAusAccess.ZugriffAusAccess = New ZugriffAusAccess.ZugriffAusAccess()
            logik.macheEtwasDirektMitDemAccessObjekt(Database)
        End Sub



        Public Function oeffneFormular(ByVal PrameterSemikolonSepariert As String) As Integer
            Dim logik As ZugriffAusAccess.ZugriffAusAccess = New ZugriffAusAccess.ZugriffAusAccess()
            logik.oeffneFormular(PrameterSemikolonSepariert)
            Return logik.Status
        End Function

        Public Sub bCreateLogikUeberMehrereFunktionen()
            logikmitLaufzeitUeberEineFunktion = New ZugriffAusAccess.ZugriffAusAccess()
        End Sub

        Public Sub bDeleteLogikUeberMehrereFunktionen()
            logikmitLaufzeitUeberEineFunktion = Nothing
        End Sub

        Public Sub oeffneFormularMitKeepAlive(ByVal prameter As String)
            logikmitLaufzeitUeberEineFunktion.oeffneFormular(prameter)
        End Sub

        Public Function GetStatusAusKeepAlive() As Integer
            Return logikmitLaufzeitUeberEineFunktion.GetSTatus()
        End Function

        Public Function GetParameterAusKeepAlive() As String
            Return logikmitLaufzeitUeberEineFunktion.parameter
        End Function

        Public Sub SetParameterFuerKeepAlive(ByVal parameter As String)
            logikmitLaufzeitUeberEineFunktion.parameter = parameter
        End Sub

        Public Function bFormGeladen() As Boolean
            Return logikmitLaufzeitUeberEineFunktion.FormIsOpen()
        End Function

        Public Function GetParameterNichtModal() As String
            Return logikmitLaufzeitUeberEineFunktion.GetParameterNichtModal()
        End Function

        Public Function GetStatusNichtModal() As Integer
            Return logikmitLaufzeitUeberEineFunktion.GetSTatusNichtModal()
        End Function
    End Class
End Namespace
